/*
 * Window.h
 *
 *  Created on: Jul 25, 2012
 *      Author: lziegler
 */

#ifndef WINDOW_H
#define WINDOW_H

#include <QtGui>
#include <boost/thread/mutex.hpp>
#include <boost/thread/thread.hpp>
#include <KGF/Grabber.h>
#include <string>

class QGroupBox;

class Window: public QDialog {
Q_OBJECT
public:
	typedef boost::shared_ptr<Window> Ptr;
	Window(std::string grabberImpl, QWidget *parent = 0);
	virtual ~Window();

	void setImages(kgf::Image<kgf::PixelRawDepth>::Ptr imgDepth,
			kgf::Image<kgf::PixelRGB>::Ptr imgRgb);

private:
	void paintEvent(QPaintEvent *event);
	QImage paintDepth(kgf::Image<kgf::PixelRawDepth>::Ptr img);
	QImage paintRgb(kgf::Image<kgf::PixelRGB>::Ptr img);

	bool doPaint;
	bool newData;
	QLabel *depthLabel;
	QLabel *rgbLabel;
	kgf::Image<kgf::PixelRawDepth>::Ptr imgDepth;
	kgf::Image<kgf::PixelRGB>::Ptr imgRgb;
	QCheckBox *paintCheck;
	boost::mutex paintMutex;
	boost::thread paintThread;

private slots:
	void togglePaint(bool paint) {
		this->doPaint = paint;
	}
};

#endif
