/*
 * Controller.h
 *
 *  Created on: Jul 26, 2012
 *      Author: lziegler
 */

#ifndef CONTROLLER_H_
#define CONTROLLER_H_

#include <KGF/Grabber.h>
#include <vector>
#include <boost/thread.hpp>
#include <boost/shared_ptr.hpp>

class Controller {
public:

	Controller(kgf::Grabber::Ptr grabber, std::string dataDir);
	virtual ~Controller();

	typedef boost::shared_ptr<Controller> Ptr;

	virtual void display(kgf::GrabObserver::Ptr listener);
	virtual void unregister(kgf::GrabObserver::Ptr listener);
	virtual void startRecStatic(std::string type);
	virtual void stopRecStatic();
	virtual void startRecMoving();
	virtual void stopRecMoving();
	virtual void setPositionStream(std::string name);
	virtual bool checkPositionStream();
	virtual void startRecPosition();
	virtual void stopRecPosition();

private:
	kgf::Grabber::Ptr grabber;
	std::vector<kgf::GrabObserver::Ptr> displayListeners;
	boost::thread dataRecThread;
	boost::thread posRecThread;
	std::string positionStream;
	std::string dataDir;
	std::string currentDir;
	void recDataLoop(std::string file);
	void recPositionLoop(std::string file);
	std::string createEmptyDir(std::string name);
};

#endif /* CONTROLLER_H_ */
