/*
 * kgList.cpp
 *
 *  Created on: Jul 16, 2012
 *      Author: lziegler
 */

#include <KGF/Grabber.h>
#include <kgfconfig.h>

#include <iostream>
#include <log4cxx/basicconfigurator.h>

#ifdef KGF_HAVE_OPENNI
#include <KGF/OpenNIGrabber.h>
#include <KGF/OpenNIPlayback.h>
#endif
#ifdef KGF_HAVE_FREENECT
/*#include <KGF/OpenKinectGrabber.h>*/
#endif
#ifdef KGF_HAVE_XCF
#include <KGF/KinectServerGrabber.h>
#endif

using namespace std;

int main(int argc, char **argv) {

	log4cxx::BasicConfigurator::configure();
	log4cxx::Logger::getRootLogger()->setLevel(log4cxx::Level::getWarn());

	cout << "\nThis is kgList" << endl;
	cout << endl;
	cout << "Available interfaces:" << endl;

#ifdef KGF_HAVE_OPENNI
	kgf::Grabber::Ptr grabo = kgf::OpenNIGrabber::Ptr(new kgf::OpenNIGrabber());
	kgf::Grabber::Ptr grabp = kgf::OpenNIPlayback::Ptr(new kgf::OpenNIPlayback(""));
	cout << "  OpenNI" << endl;
#endif
#ifdef KGF_HAVE_FREENECT
	/*kgf::Grabber::Ptr grabf = kgf::OpenKinectGrabber::Ptr(new kgf::OpenKinectGrabber());*/
	cout << "  Freenect" << endl;
#endif
#ifdef KGF_HAVE_XCF
	kgf::Grabber::Ptr grabx = kgf::KinectServerGrabber::Ptr(new kgf::KinectServerGrabber());
	cout << "  XCF" << endl;
#endif

	cout << endl;
	cout << "Done" << endl;
}
