/*
 * kgPcl.cpp
 *
 *  Created on: Oct 25, 2012
 *      Author: lziegler
 */

#include <KGF/kgf.h>
#include <KGF/GrabberUtils.h>

#include <pcl/point_cloud.h>

#include <log4cxx/basicconfigurator.h>

using namespace std;

int main(int argc, char **argv) {

	log4cxx::BasicConfigurator::configure();
	log4cxx::Logger::getRootLogger()->setLevel(log4cxx::Level::getWarn());

	cout << "\nThis is kgPcl" << endl;
	cout << endl;

	{
		// auto select a grabber
		kgf::Grabber::Ptr grabber = kgf::autoSelectGrabber();

		// configure and initialize the grabber
		kgf::GrabConfigurationDepth configD(640, 480, 30);
		kgf::GrabConfigurationRgb configR(640, 480, 30);
		grabber->init(configR, configD);

		// enable the calculation of the pointcloud
		grabber->setXyzEnabled(true);

		// grab for 2 seconds
		long timeStartMilli = kgf::GrabberUtils::currentTimeMillis();
		while (kgf::GrabberUtils::currentTimeMillis() < timeStartMilli + 2000) {

			// wait for new data
			grabber->next();

			// get the data
			pcl::PointCloud<pcl::PointXYZ>::Ptr pclCloud =
					kgf::GrabberUtils::toPclCloud(grabber->getLastImageXYZ());

			cout << "have pcl pointcloud" << endl;
		}
		cout << endl;
		cout << "Shutting down..." << endl;
	}
	// grabber should be shut down at this point

	cout << "Done" << endl;
}
