/*
 * FreenectTest.cpp
 *
 *  Created on: Nov 13, 2012
 *      Author: lziegler
 */

#include <KGF/OpenNIPlayback.h>
#include <KGF/GrabberUtils.h>

#include <log4cxx/basicconfigurator.h>

using namespace std;

int main(int argc, char **argv) {

	log4cxx::BasicConfigurator::configure();
	log4cxx::Logger::getRootLogger()->setLevel(log4cxx::Level::getWarn());

	cout << "\nThis is kgOniTest" << endl;
	cout << endl;

	if (argc != 2) {
		cerr << "Error: No argument\n\nUsage:\n$ kgOniTest <file>\n" << endl;
		return 1;
	}

	{
		// auto select a grabber
		kgf::OpenNIPlayback::Ptr grabber(new kgf::OpenNIPlayback(argv[1]));

		// configure and initialize the grabber
		kgf::GrabConfigurationDepth configD(640, 480, 30);
		kgf::GrabConfigurationRgb configR(640, 480, 30);
		grabber->init(configR, configD);

		kgf::Image<kgf::PixelRGB>::Ptr imgRgb;
		kgf::Image<kgf::PixelRawDepth>::Ptr imgDepth;

		// grab for 2 seconds
		long timeStartMilli = kgf::GrabberUtils::currentTimeMillis();
		while (kgf::GrabberUtils::currentTimeMillis() < timeStartMilli + 2000) {

			// wait for new data
			grabber->next();

			// get the data
			imgRgb = grabber->getLastImageRGB();
			imgDepth = grabber->getLastImageDepth();

			cout << "received images" << endl;
		}
		cout << endl;
		cout << "Shutting down..." << endl;
	}
	// grabber should be shut down at this point

	cout << "Done" << endl;
}
